--
-- emptyFillable
--
-- @author:    	Xentro (www.fs-uk.com)(Marcus@Xentro.se)
-- @version:    v0.9
-- @date:       2013-04-14
-- 
--[[

]]--

emptyFillable = {};

function emptyFillable.prerequisitesPresent(specializations)
	if not SpecializationUtil.hasSpecialization(Fillable, specializations) then print("Warning: Specialization emptyFillable needs the specialization Fillable."); end;
	
	return SpecializationUtil.hasSpecialization(Fillable, specializations);
end;

function emptyFillable:load(xmlFile)
	local input = getXMLString(xmlFile, "vehicle.emptyFillable#inputBinding");
	if input ~= nil and InputBinding[input] ~= nil then
		self.emptyFillabelInput = InputBinding[input];
	else
		self.emptyFillabelInput = InputBinding.IMPLEMENT_EXTRA2;
	end;
	
	local emptyInteractionNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.emptyFillable#interactionNode"));
	if emptyInteractionNode ~= nil then
		self.emptyInteractionNode = emptyInteractionNode;
	end;
	
	self.emptyScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.emptyFillable#emptyScale"), 5);
	
	self.emptyParticles = {};
    Utils.loadParticleSystem(xmlFile, self.emptyParticles, "vehicle.emptyFillable.particles", self.components, false, nil, self.baseDirectory);
	
	self.isEmtyingFillable = false;
	self.allowEmpty = true;
end;

function emptyFillable:delete()
	if self.emptyParticles ~= nil then
		Utils.deleteParticleSystem(self.emptyParticles);
	end;
end;

function emptyFillable:readStream(streamId, connection)
end;

function emptyFillable:writeStream(streamId, connection)
end;

function emptyFillable:mouseEvent(posX, posY, isDown, isUp, button)
end;

function emptyFillable:keyEvent(unicode, sym, modifier, isDown)
end;

function emptyFillable:update(dt)
	if self.isClient then
		if g_currentMission.controlPlayer and g_currentMission.player ~= nil and self.emptyInteractionNode ~= nil and self.emptyFillabelInput ~= nil and self.allowEmpty then
			local x, y, z = getWorldTranslation(self.emptyInteractionNode);
			local px, py, pz = getWorldTranslation(g_currentMission.player.rootNode);
			local distance = Utils.vector3Length(x - px, y - py, z - pz);
			if distance < 1.5 then
				if g_gui.currentGui == nil and not g_currentMission.isPlayerFrozen then
					if InputBinding.isPressed(self.emptyFillabelInput) then
						if self.fillLevel > 0 then
							self.setFillLevel(self.fillLevel - (self.fillLevel - self.emptyScale), self.currentFillType);
							self.isEmtyingFillable = true;
						end;
					else
						if self.isEmtyingFillable then
							self.isEmtyingFillable = false;
						end;
					end;
				end;
				
				if g_i18n:hasText("REMOVE_FILLLEVEL") then
					g_currentMission:addHelpButtonText(g_i18n:getText("REMOVE_FILLLEVEL"), self.emptyFillabelInput);
				end;
				
				if g_i18n:hasText("CURRENT_FILLLEVEL") then
					g_currentMission:addExtraPrintText(string.format(g_i18n:getText("CURRENT_FILLLEVEL"), self.fillLevel));
				end;
			end;
		end;
		
		if self.emptyParticles ~= nil then
			local isEmptying = self.fillLevel > 0 and self.isEmtyingFillable;
			
			Utils.setEmittingState(self.emptyParticles, isEmptying);
		end;
	end;
end;

function emptyFillable:updateTick(dt)
end;

function emptyFillable:draw()
end;